/*----------------------------------------------------------------------
 *
 * MicroStrain Interface Software
 *
 * (c) 2008 Microstrain, Inc.
 * All rights reserved.
 *
 * www.microstrain.com
 * 310 Hurricane Lane, Suite 4
 * Williston, VT 05495 USA
 * Tel: 802-862-6629 tel
 * Fax: 802-863-4093 fax
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 * i3dmgx2Serial.h
 *
 * definitions and prototype declarations for the serial port functions.
 *----------------------------------------------------------------------*/

#define MAX_PORT_NUM 256

#define I3DMGX2_COMM_NOPARITY 0
#define I3DMGX2_COMM_ODDPARITY 1
#define I3DMGX2_COMM_EVENPARITY 2

#define I3DMGX2_COMM_ONESTOPBIT 1
#define I3DMGX2_COMM_TWOSTOPBITS 2


/*----------------------------------------------------------------------
 * function prototypes
 *----------------------------------------------------------------------*/

int openPort(int, int, int);
void closePort(int);
int setCommParameters(int, int, int, int, int);
int setCommTimeouts(int, int, int);
int sendBuffData(int, char *, int);
int receiveData(int, char*, int);
int purge_port( int);
/*-------------- end of i3dmgx2Serial.h ---------------------------------*/
