/*----------------------------------------------------------------------
 *
 * I3DM-GX2 Interface Software
 *
 * (c) 2008 Microstrain, Inc.
 * All rights reserved.
 *
 * www.microstrain.com
 * 310 Hurricane Lane, Suite 4
 * Williston, VT 05495 USA
 * Tel: 802-862-6629
 * Fax: 802-863-4093
 *--------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 * i3dmgx2Utils.h
 *
 * Miscellaneous untility functions used by the 3DM-GX2 Adapter.
 *--------------------------------------------------------------------*/

#define LSB_MASK 0xFF
#define MSB_MASK 0xFF00
#define BIG_ENDIAN      0
#define LITTLE_ENDIAN   1

#include <stdio.h>
#include <windows.h>

short convert2short(char *);
unsigned short convert2ushort(char *);
unsigned long convert2ulong(BYTE *);
long convert2long(BYTE*);
int calcChecksum(char *, int);
WORD i3dmgx2_Checksum(const BYTE*, int);
float FloatFromBytes(const BYTE*); 
char * explainError(int);
int TestByteOrder();

/*-------------- end of i3dmgx2Utils.h ----------------------*/
