Public Class Main
    '*----------------------------------------------------------------------
    '* (c) 2008 Microstrain, Inc.
    '*----------------------------------------------------------------------
    '* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING 
    '* CUSTOMERS WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER 
    '* FOR THEM TO SAVE TIME. AS A RESULT, MICROSTRAIN SHALL NOT BE HELD LIABLE 
    '* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY 
    '* CLAIMS ARISING FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY 
    '* CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH 
    '* THEIR PRODUCTS.
    '*----------------------------------------------------------------------
    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'populate comm port combo box
        Dim X As Integer
        For X = 1 To 32
            cmbCommPort.Items.Add(Trim(Str(X)))
        Next
        'populate channel combo box
        Dim Y As Integer
        For Y = 0 To 7
            cmbChannel.Items.Add(Trim(Str(Y)))
        Next
        'Sets a value indicating whether to catch calls on the wrong thread that access a control's Handle property 
        txtHeader.CheckForIllegalCrossThreadCalls = False
        txtMSB.CheckForIllegalCrossThreadCalls = False
        txtLSB.CheckForIllegalCrossThreadCalls = False
        txtDataWord.CheckForIllegalCrossThreadCalls = False
        txtVolts.CheckForIllegalCrossThreadCalls = False
        txtASCII.CheckForIllegalCrossThreadCalls = False
        txtHex.CheckForIllegalCrossThreadCalls = False
        txtDecimal.CheckForIllegalCrossThreadCalls = False

    End Sub

    Private Sub SampleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SampleToolStripMenuItem.Click
        'set error handler
        On Error GoTo ErrorHandler

        'test for comm port selection
        If cmbCommPort.Text = "" Then
            'event
            Call ReportEvent("Comm Port not selected")
            'exit
            Exit Sub
        End If

        'test for channel selection
        If cmbChannel.Text = "" Then
            'event
            Call ReportEvent("Channel not selected")
            'exit
            Exit Sub
        End If

        'determine action based on menu check
        If SampleToolStripMenuItem.Checked = False Then
            'event
            Call ReportEvent("Sampling started")
            'set menu check
            SampleToolStripMenuItem.Checked = True
            'disable combos
            cmbCommPort.Enabled = False
            cmbChannel.Enabled = False
            'set serial port number
            SerialPort1.PortName() = "COM" + Trim(cmbCommPort.Text)
            'set receive threshold
            SerialPort1.ReceivedBytesThreshold = 3
            'open serial port
            SerialPort1.Open()
            'populate byte array with polling command for channel
            ReDim arrBytes(0 To 0)
            arrBytes(0) = MyCommandByte
            'send command
            SerialPort1.Write(arrBytes, 0, 1)
        ElseIf SampleToolStripMenuItem.Checked = True Then
            'open serial port
            SerialPort1.Close()
            'event
            Call ReportEvent("Sampling stopped")
            'set menu check
            SampleToolStripMenuItem.Checked = False
            'set packet indicator
            lblPacket.ForeColor = Color.Red
            'enable combos
            cmbCommPort.Enabled = True
            cmbChannel.Enabled = True
        End If

        Exit Sub
ErrorHandler:
        'open serial port
        If SerialPort1.IsOpen = True Then SerialPort1.Close()
        'event
        Call ReportEvent("Sampling errored: " + Err.Description)
        'set menu check
        SampleToolStripMenuItem.Checked = False
        'set packet indicator
        lblPacket.ForeColor = Color.Red
        'enable combos
        cmbCommPort.Enabled = True
        cmbChannel.Enabled = True
        'exit
        Exit Sub
    End Sub

    Private Sub cmbChannel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbChannel.SelectedIndexChanged
        'determine command
        If Val(cmbChannel.Text) = 0 Then
            MyCommandByte = 102
        ElseIf Val(cmbChannel.Text) = 1 Then
            MyCommandByte = 120
        ElseIf Val(cmbChannel.Text) = 2 Then
            MyCommandByte = 121
        ElseIf Val(cmbChannel.Text) = 3 Then
            MyCommandByte = 119
        ElseIf Val(cmbChannel.Text) = 4 Then
            MyCommandByte = 109
        ElseIf Val(cmbChannel.Text) = 5 Then
            MyCommandByte = 110
        ElseIf Val(cmbChannel.Text) = 6 Then
            MyCommandByte = 111
        ElseIf Val(cmbChannel.Text) = 7 Then
            MyCommandByte = 112
        End If
        'populate ascii, hex and decimal equivalent in textboxes
        txtASCII.Text = Chr(MyCommandByte)
        txtHex.Text = Hex(MyCommandByte)
        txtDecimal.Text = MyCommandByte
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        'quit app
        End
    End Sub

    Private Function ReportEvent(ByVal MyEvent As String) As Boolean
        'add event to text
        If txtEvent.Text = "" Then
            txtEvent.Text = MyEvent
        Else
            txtEvent.Text = txtEvent.Text + Chr(13) + Chr(10) + MyEvent
        End If
    End Function

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        'set error handler
        On Error GoTo ErrorHandler

        'set variable
        UpperLimitOfArray = SerialPort1.BytesToRead - 1
        'prep array
        ReDim arrBytes(0 To UpperLimitOfArray)
        'get comm buffer
        SerialPort1.Read(arrBytes, 0, SerialPort1.BytesToRead)

        'test for no byte return
        If UBound(arrBytes) = -1 Then
            'set packet indicator
            lblPacket.ForeColor = Color.Red
            'populate byte array with polling command for channel
            ReDim arrBytes(0 To 0)
            arrBytes(0) = MyCommandByte
            'send command
            SerialPort1.Write(arrBytes, 0, 1)
            'exit
            Exit Sub
        End If

        'test 3 byte return and header
        If Not UBound(arrBytes) = 2 And Not arrBytes(0) = 255 Then
            'set packet indicator
            lblPacket.ForeColor = Color.Red
            'populate byte array with polling command for channel
            ReDim arrBytes(0 To 0)
            arrBytes(0) = MyCommandByte
            'send command
            SerialPort1.Write(arrBytes, 0, 1)
            'exit
            Exit Sub
        End If

        'set packet indicator
        lblPacket.ForeColor = Color.Green

        'display data
        txtHeader.Text = arrBytes(0)
        txtMSB.Text = arrBytes(1)
        txtLSB.Text = arrBytes(2)
        MyDataWord = (CDbl(arrBytes(1)) * 256) + arrBytes(2)
        txtDataWord.Text = MyDataWord
        MyVolts = (MyDataWord - 8192) * 0.0006103
        txtVolts.Text = MyVolts

        'populate byte array with polling command for channel
        ReDim arrBytes(0 To 0)
        arrBytes(0) = MyCommandByte
        'send command
        SerialPort1.Write(arrBytes, 0, 1)

        Exit Sub
ErrorHandler:
        'close serial port
        If SerialPort1.IsOpen = True Then SerialPort1.Close()
        'exit 
        Exit Sub
    End Sub
End Class
